module Cutil_12 (addr2int, int2addr, fpeek, Storable(..), free, malloc,
		 module Bits,
		 module Int,
		 module PrelPtr,
		 module CString) where


{-	This module contains some additional routines required for marshalling 
	Haskell arguments to OS C calling routines.
-}

import Bits
import Int
import PrelPtr
import CString
import Storable(peek, Storable(..))
import MarshalAlloc(free, malloc)
import IOExts

--	Conversion operations:

addr2int :: Ptr a -> Int
addr2int a = unsafePerformIO (_casm_GC_ ``%r = (int) %0;'' a)

int2addr :: Int -> Ptr a
int2addr x = unsafePerformIO (_casm_GC_ ``%r = (void *) %0;'' x)
   

--	fpeek addr first peeks addr, then frees addr:
fpeek :: (Storable a) => Ptr a -> IO a
fpeek addr
	= do {
		x <- peek addr;
		free addr;
		return x
	  }