{-# OPTIONS -cpp #-}

module ReceiverAccess ( newReceiverStateHandle,  newReceiverHandle
--                    , newReceiverStateHandle2, newReceiverHandle2
                      ) where


--	********************************************************************************
--	Clean Standard Object I/O library, version 1.2
--	
--	ReceiverAccess contains ReceiverHandle access.
--	********************************************************************************


import Id
import ReceiverDefAccess
import ReceiverHandle
import IOState(GUI)
#include "preprocess.h"
         -- Compile with -cpp; set MVAR=1 for MVAR version


newReceiverStateHandle :: RId m r -> IF_MVAR(,ls ->) SelectState -> [Id] -> ReceiverFunction m r IF_MVAR(,ls ps) -> ReceiverStateHandle IF_MVAR(,ps)
newReceiverStateHandle rid IF_MVAR(,localState) select connectedIds f
#if MVAR
	= ReceiverStateHandle (newReceiverHandle rid select connectedIds f)
#else
	= ReceiverStateHandle localState (newReceiverHandle rid select connectedIds f)
#endif

newReceiverHandle :: RId m r -> SelectState -> [Id] -> ReceiverFunction m r IF_MVAR(,ls ps) -> ReceiverHandle m r IF_MVAR(,ls ps)
newReceiverHandle rid select connectedIds f
	= ReceiverHandle
		{ rId        = rIdtoId   rid
		, rASMQ      = getRIdIn  rid
		, rASRQ      = getRIdOut rid
		, rSelect    = select
		, rFun       = f
	--	, rInetInfo  = Nothing
	--	, rConnected = connectedIds
		}
