module StdMenuReceiver(MenuElements(..)) where


--	Clean Object I/O library, version 1.2

import	CommonDef
import	StdIOCommon
import	StdReceiverAttribute
import	StdMenuElementClass
import	StdMenuDef
import	MenuHandle
import	ReceiverAccess(newReceiverHandle{-, newReceiverHandle2-})


instance MenuElements (Receiver m r) where
	menuElementToHandles (Receiver rid f atts) =
		return [menuElementHandleToMenuElementState
				(MenuReceiverHandle (newReceiverHandle rid (getSelectState atts) (getConnectedIds atts) f)
						(MenuId (rIdtoId rid):map receiverAttToMenuAtt atts))
			]
		

getSelectState :: [ReceiverAttribute ls ps] -> SelectState
getSelectState rAtts = getReceiverSelectStateAtt (snd (cselect isReceiverSelectState (ReceiverSelectState Able) rAtts))

getConnectedIds :: [ReceiverAttribute ls ps] -> [Id]
{-	TCP support not yet incorporated
getConnectedIds rAtts = getReceiverConnectedReceivers (snd (cselect isReceiverConnectedReceivers (ReceiverConnectedReceivers []) rAtts))
-}
getConnectedIds rAtts = []	

receiverAttToMenuAtt :: ReceiverAttribute ls ps -> MenuAttribute ls ps
receiverAttToMenuAtt (ReceiverSelectState s) = MenuSelectState s
