{-# OPTIONS -cpp #-}

module StdWindowDef ( module StdWindowDef
                    , module StdIOCommon
                    , module StdGUI
                    , Look, PenAttribute(..)
                    ) where


--	********************************************************************************
--	Clean to Haskell Standard Object I/O library, version 1.2
--	
--	StdWindowDef contains the types to define the standard set of dialogs.
--	********************************************************************************


import StdGUI
import StdIOCommon
import StdPictureDef(PenAttribute(..))
import StdPicture(Look)
#include "preprocess.h"
         -- Compile with -cpp; set MVAR=1 for MVAR version


#if MVAR
data	Dialog c = Dialog Title c [WindowAttribute]
data	Window c = Window Title c [WindowAttribute]
#else
data	Dialog c ls ps = Dialog Title (c ls ps) [WindowAttribute ls ps]
data	Window c ls ps = Window Title (c ls ps) [WindowAttribute ls ps]
#endif

data	WindowAttribute IF_MVAR(,ls ps)              -- Default:
 --	Attributes for Windows and Dialogs:
 =	WindowActivate   (GUIFun IF_MVAR((),ls ps))  -- id
 |	WindowClose      (GUIFun IF_MVAR((),ls ps))  -- user can't close window
 |	WindowDeactivate (GUIFun IF_MVAR((),ls ps))  -- id
 |	WindowHMargin	 Int Int		     -- system dependent
 |	WindowId         Id                          -- system defined id
 |	WindowIndex	 Int			     -- open front-most
 |	WindowInit       (GUIFun IF_MVAR((),ls ps))  -- no actions after opening window
 |	WindowInitActive Id			     -- system dependent
 |	WindowItemSpace	 Int Int		     -- system dependent
 |	WindowOuterSize	 Size			     -- screen size
 |	WindowPos	 ItemPos		     -- system dependent
 |	WindowViewSize   Size                        -- screen size
 |	WindowVMargin	 Int Int		     -- system dependent
 --	Attributes for Dialog only:	
 |	WindowCancel	 Id			     -- no cancel  (Custom)ButtonControl
 |	WindowOk	 Id			     -- no default (Custom)ButtonControl
 --	Attributes for Windows only:	
 | 	WindowCursor	 CursorShape		     -- no change of cursor
 |	WindowHScroll	 ScrollFunction		     -- no horizontal scrolling
 |	WindowKeyboard	 KeyboardStateFilter SelectState (KeyboardFunction IF_MVAR(,ls ps)) -- no keyboard input
 |	WindowLook	 Bool Look		     -- show system dependent background
 |	WindowMouse	 MouseStateFilter SelectState (MouseFunction IF_MVAR(,ls ps)) -- no mouse input
 |	WindowOrigin	 Point2			     -- left top of picture domain
 |	WindowPen	 [PenAttribute]		     -- default pen attributes
 |	WindowSelectState	SelectState	     -- Able
 |	WindowViewDomain	ViewDomain	     -- {zero,max range}
 |	WindowVScroll		ScrollFunction	     -- no vertical scrolling